<template>
  <table class="solution-table">
    <tr
      v-for="(code, lineNo) in highlightedSolution"
      :id="`solution-line-${lineNo}`"
      :key="`${pk}:${lineNo}`"
    >
      <td
        class="line-number-cell"
        :style="backgroundColor(lineNo)"
      >
        <v-btn
          text
          block
          depressed
          class="line-number-btn"
          @click="toggleEditor(lineNo)"
        >
          {{ lineNo }}
        </v-btn>
      </td>
      <td class="code-cell-content pl-2">
        <!-- eslint-disable-next-line -->
        <span class="code-line" v-html="code"/>
        <template
          v-if="solutionComments[lineNo] && solutionComments[lineNo].length && showSolutionComments"
        >
          <solution-comment
            v-for="comment in solutionComments[lineNo]"
            :key="comment.pk"
            v-bind="comment"
            @update-submission-type="updateSubmissionType"
            @toggle-editor="toggleEditor(lineNo)"
            @toggle-eidt-editor="toggleEditor(lineNo)"
          />
        </template>
        <template v-if="showEditorOnline[lineNo]">
          <v-textarea
            v-model="editedSolutionComments[lineNo]"
            name="solution-comment-input"
            label="Here you can comment the solution. Other tutors will see those comments."
            rows="2"
            outlined
            autofocus
            auto-grow
            hide-details
            class="mx-2"
            @keyup.enter.ctrl.exact="submitSolutionComment(lineNo)"
            @keyup.esc="collapseTextField(lineNo)"
            @focus="selectInput($event)"
          />
          <v-btn
            id="submit-comment"
            color="success"
            @click="submitSolutionComment(lineNo)"
          >
            <v-icon>check</v-icon>Submit
          </v-btn>
          <v-btn
            id="cancel-comment"
            @click="toggleEditor(lineNo)"
          >
            <v-icon>cancel</v-icon>cancel
          </v-btn>
        </template>
      </td>
    </tr>
  </table>
</template>

<script lang="ts">
  import { Vue, Component, Prop } from 'vue-property-decorator'
  import { SolutionComment, FeedbackComment } from '../../../models'
  import { highlight } from 'highlight.js'
  import { syntaxPostProcess, objectifyArray } from '../../../util/helpers'
  import SolutionCommentComponent from '@/components/submission_type/solution/SolutionComment.vue'
  import * as api from '@/api'
  import { actions } from '../../../store/actions'

  @Component({
    components: {'SolutionComment': SolutionCommentComponent}
  })
  export default class Solution extends Vue {
    @Prop({
      type: String,
      required: true
    })
    pk!: string
    @Prop({
      type: String,
      required: false,
      default: ''
    })
    solution!: string
    @Prop({
      type: String,
      default: 'c'
    })
    programmingLanguage!: string
    @Prop({
      type: Object,
      default: {}
    })
    solutionComments!: { [ofLine: number]: SolutionComment[] }
    @Prop({
      type: Boolean,
      default: true
    })
    showSolutionComments!: boolean
    @Prop({
      type: Boolean,
      default: true
    })
    editable!: boolean

    timer = 0
    showEditorOnline: {[ofLine: number]: boolean} = {}
    editedSolutionComments: {[ofLine: number]: string} = {}

    get highlightedSolution() {
      const highlighted = highlight(this.programmingLanguage, this.solution, true)
        .value
      const postprocessed = syntaxPostProcess(highlighted)
      return postprocessed
        .split('\n')
        .reduce((acc: { [k: number]: string }, curr, index) => {
          acc[index + 1] = curr
          return acc
        }, {})
    }

    get lineNoHint() {
      if (this.showSolutionComments) {
        // will return a falsy value if indexed with a line number
        // meaning no hint will be displayed
        return {}
      } else {
        // returning the solutionComments will return a truthy value
        // if indexed with the line number where comments are located
        return this.solutionComments
      }
    }

    backgroundColor(lineNo: number) {
      if (this.lineNoHint[lineNo]) {
        return 'backgroundColor: #64B5F6;'
      } else {
        'backgroundColor: transparent;'
      }
    }

    selectInput (event: Event) {
      if (event !== null) {
        const target = event.target as HTMLTextAreaElement
        target.select()
      }
    }

    toggleEditor(lineNo: number) {
      if (this.editable) {
        Vue.set(this.showEditorOnline, lineNo, !this.showEditorOnline[lineNo])
      }
    }

    async submitSolutionComment(lineNo: number) {
      const comment = {
        text: this.editedSolutionComments[lineNo],
        ofLine: lineNo,
        ofSubmissionType: this.pk
      }
      await api.createSolutionComment(comment)
      await actions.updateSubmissionType(this.pk)
      this.toggleEditor(lineNo)
      this.editedSolutionComments[lineNo] = ''
    }

    updateSubmissionType() {
      actions.updateSubmissionType(this.pk)
    }

    mounted() {
      this.timer = setInterval(() => {
        actions.updateSubmissionType(this.pk)
      }, 10 * 1e3)
    }

    beforeDestroy() {
      clearInterval(this.timer)
    }
  }
</script>

<style scoped>
  .solution-table {
    table-layout: auto;
    border-collapse: collapse;
    width: 100%;
  }

  .line-number-cell {
    vertical-align: top
  }

  .code-cell-content {
    width: 100%
  }

  .code-line {
    white-space: pre-wrap;
    font-family: monospace;
  }

  .line-number-btn {
    height: fit-content;
    min-width: 50px;
    margin: 0;
    border-radius: 0px;
  }
</style>
